#### Generate karyotype files for Circos ####
setwd('~/Desktop/Old_Desktop/Map Paper/DATA/')
plotdir <- '~/Desktop/Old_Desktop/Map Paper/raw_figures'
x <- c('stringr','reshape2','gdata')
lapply(x, require, character.only = TRUE)
#### Killifish ####
fhet <- c(1:24)
write.table(data.frame(chr='chr - ',paste('FH',fhet,sep = ''),fhet=fhet,0,max=sapply(fhet, function(x) max(gff[which(gff$V1==x),5])),paste('chr',fhet,sep = '')),file='~/Desktop/Circos/fhet.karyotype.txt',quote = FALSE, col.names = FALSE, row.names = FALSE)
write.table(data.frame(paste('FH',fhet,sep = ''),0,max=sapply(fhet, function(x) max(gff[which(gff$V1==x),5]))),file='fhet.highlights.txt',quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/fhet.karyotype.txt ~/software/circos/current/fhet.karyotype.txt')
#system('cp ~/Desktop/Circos/fhet.highlights.txt ~/software/circos/current/fhet.highlights.txt')
####################
#### Platyfish ####
platyfish.genome <- read.table('xma_washu_4.4.2-jhp_1.0.flat.agp', stringsAsFactors = FALSE)
platyfish.genome$V1 <- gsub('LG', '', platyfish.genome$V1)
platyfish.chr.length <- data.frame(chrm=unique(platyfish.genome$V1), length=NA)
for (i in 1:length(unique(platyfish.genome$V1))){
  platyfish.chr.length$length[i] <- max(platyfish.genome[which(platyfish.genome$V1==platyfish.chr.length$chrm[i]),3])
}
row.names(platyfish.chr.length) <- platyfish.chr.length$chrm
platyfish.karyotpe <- data.frame(chr='chr -', lab=paste('XM',platyfish.chr.length$chrm, sep = ''),chr.num=platyfish.chr.length$chrm, strt=0,end=platyfish.chr.length$length, color=paste('chr',platyfish.chr.length$chrm, sep = ''))
write.table(platyfish.karyotpe, file='platyfish.karyotype.txt', quote = FALSE, col.names = FALSE, row.names = FALSE) ## karyotpe file M and F)
#system('cp ~/Desktop/Circos/platyfish.karyotype.txt ~/software/circos/current/platyfish.karyotype.txt')
write.table(data.frame(platyfish.karyotpe$lab, platyfish.karyotpe$strt,platyfish.karyotpe$end),file='platy.highlights.txt', quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/platy.highlights.txt ~/software/circos/current/platy.highlights.txt')
###################
#### medaka ####
## Chromsome info downloaded from (http://hgdownload.soe.ucsc.edu/goldenPath/oryLat2/database/chromInfo.txt.gz) ##
medaka.chrom.def <- read.table('chromInfo.medaka.txt', stringsAsFactors = FALSE)
medaka.chrom.def$V1 <- gsub('chr', 'OL',medaka.chrom.def$V1)
medaka.chrom.def <- data.frame(chrm=medaka.chrom.def$V1,start=0,stop=medaka.chrom.def$V2)
medaka.chrom.def <- medaka.chrom.def[medaka.chrom.def$chrm%in%paste('OL',c(1:24),sep = ''),]
rownames(medaka.chrom.def) <- medaka.chrom.def$chrm
write.table(data.frame(chr='chr -', 
                       lab=medaka.chrom.def$chr,chr.num=gsub('OL','',medaka.chrom.def$chrm), 
                       strt=0,end=medaka.chrom.def$stop, 
                       color=paste('chr',gsub('OL','',medaka.chrom.def$chrm), sep = '')),
            file='medaka.karyotype.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/medaka.karyotype.txt ~/software/circos/current/medaka.karyotype.txt')
write.table(data.frame(lab=gsub('chr','',medaka.chrom.def$chrm), 
                       strt=0,end=medaka.chrom.def$stop), 
            file='medaka.highlights.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp  ~/Desktop/Circos/medaka.highlights.txt ~/software/circos/current/medaka.highlights.txt')
####################
#### stickleback #####
## Chromsome info downloaded from (http://http://hgdownload.soe.ucsc.edu/goldenPath/gasAcu1/bigZips/gasAcu1.chrom.sizes) ##
stickleback.chrom.def <- read.table('gasAcu1.chrom.sizes', stringsAsFactors = FALSE)
row.names(stickleback.chrom.def) <- stickleback.chrom.def$V1
stickleback.chrom.def <- stickleback.chrom.def[!is.na(as.roman(gsub('chr','',stickleback.chrom.def$V1))),]
stickleback.chrom.def$V1 <- gsub('chr','',stickleback.chrom.def$V1) 
stickleback.chrom.def$V1 <- as.numeric(as.roman(stickleback.chrom.def$V1))
stickleback.chrom.def <- data.frame(chrm=stickleback.chrom.def$V1,start=0,stop=stickleback.chrom.def$V2)
stickleback.karyotpe <- data.frame(chr='chr -', 
                                   lab=paste('GA',stickleback.chrom.def$chrm, sep = ''),
                                   chr.num=stickleback.chrom.def$chrm, 
                                   strt=0,end=stickleback.chrom.def$stop, 
                                   color=paste('chr',stickleback.chrom.def$chrm, sep = ''))
write.table(stickleback.karyotpe, file='stickleback.karyotype.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE) ## karyotpe file M and F)
#system('cp ~/Desktop/Circos/stickleback.karyotype.txt ~/software/circos/current/stickleback.karyotype.txt')
write.table(data.frame(lab=paste('GA',gsub('chr','',stickleback.chrom.def$chrm),sep = ''), 
                       strt=0,end=stickleback.chrom.def$stop), 
            file='stickleback.highlights.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp  ~/Desktop/Circos/stickleback.highlights.txt ~/software/circos/current/stickleback.highlights.txt')
####################
#### zebrafish ####
## Chromsome info downloaded from (  ) ##
zebrafish.chrom.def <- read.table('chromInfo.zebrafish.txt', stringsAsFactors = FALSE)
zebrafish.chrom.def$V1 <- gsub('chr', 'DR ',zebrafish.chrom.def$V1)
zebrafish.chrom.def <- data.frame(chrm=zebrafish.chrom.def$V1,start=0,stop=zebrafish.chrom.def$V2)
zebrafish.chrom.def$stop <- as.numeric(gsub(',','',zebrafish.chrom.def$stop))
zebrafish.karyotpe <- data.frame(chr='chr -', 
                                 lab=paste('DR',zebrafish.chrom.def$chrm, sep = ''),
                                 chr.num=zebrafish.chrom.def$chrm, 
                                 strt=0,
                                 end=zebrafish.chrom.def$stop, 
                                 color=paste('chr',zebrafish.chrom.def$chrm, sep = ''))
write.table(zebrafish.karyotpe, 
            file='zebrafish.karyotype.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE) ## karyotpe file M and F)
#system('cp ~/Desktop/Circos/zebrafish.karyotype.txt ~/software/circos/current/zebrafish.karyotype.txt')
write.table(data.frame(paste('DR',zebrafish.chrom.def$chrm,sep = ''),
                       zebrafish.chrom.def$start,zebrafish.chrom.def$stop),
            file='zebrafish.highlights.txt',
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/zebrafish.highlights.txt ~/software/circos/current/zebrafish.highlights.txt')
##################
#### spotgar #####
spotgar.order <- c(6,2,20,8,7,18,25,11,15,3,27,12,22,10,4,13,5,17,24,23,21,19,9,1,16,14,26,28,29)
spotgar.chrom.def <- read.table('GCA_000242695.1_sequence_report.txt', header = TRUE, sep = '\t')
spotgar.chrom.def <- spotgar.chrom.def[grep('LG', spotgar.chrom.def$sequence.name),]
spotgar.chrom.def <- data.frame(chrm=gsub('LG','LO',spotgar.chrom.def$sequence.name),
                                stop=spotgar.chrom.def$sequence.length, 
                                row.names = gsub('LG','LO',spotgar.chrom.def$sequence.name))
spotgar.chrom.def <- spotgar.chrom.def[paste('LO',rev(spotgar.order),sep=''),]
write.table(data.frame(chr.dash='chr -', 
                       chr=spotgar.chrom.def$chrm,
                       lab=gsub('LO','',spotgar.chrom.def$chrm),
                       start=0,
                       stp=spotgar.chrom.def$stop, 
                       color=paste('chr',gsub('LO','',spotgar.chrom.def$chrm),sep = '')), 
            file='~/Desktop/Circos/spotgar.karyotype.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE) ## karyotpe file M and F)
#system('cp ~/Desktop/Circos/spotgar.karyotype.txt ~/software/circos/current/spotgar.karyotype.txt')
write.table(data.frame(chr=spotgar.chrom.def$chrm, 
                       strt=0,
                       stp=spotgar.chrom.def$stop),
            file='~/Desktop/Circos/spotgar.highlights.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/spotgar.highlights.txt ~/software/circos/current/spotgar.highlights.txt')
####################
#### human ####
## Chromsome info downloaded from (  ) ##
human.chrom.def <- read.table('hg38.chrom.sizes', stringsAsFactors = FALSE) ##
human.chrom.def$V1 <- paste('HS',gsub('chr','',human.chrom.def$V1),sep = '')
human.chrom.def <- human.chrom.def[gsub('HS','',human.chrom.def$V1)%in%c(1:22,'X'),]
human.chrom.def$V1[which(human.chrom.def$V1=='HSX')] <- 'HS23'
row.names(human.chrom.def) <- gsub('HS','',human.chrom.def$V1)
write.table(data.frame(chr='chr -',
                       chrm=human.chrom.def$V1,
                       chrl=gsub('HS','',human.chrom.def$V1),
                       start=0,
                       stop=human.chrom.def$V2,
                       color=gsub('HS','chr',human.chrom.def$V1)),
            file='~/Desktop/Circos/human.karyotype.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/human.karyotype.txt ~/software/circos/current/human.karyotype.txt')
write.table(data.frame(chrm=human.chrom.def$V1, 
                       start=0,
                       stp=human.chrom.def$V2),
            file='human.highlights.txt', 
            quote = FALSE, col.names = FALSE, row.names = FALSE)
#system('cp ~/Desktop/Circos/human.highlights.txt ~/software/circos/current/human.highlights.txt')
##############
##################END####################




